VSTGUI: CBitmapPixelAccess Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
CBitmapPixelAccess Class Referenceabstract
New classes » Version 4.0

direct pixel access to a CBitmap More...

`#include <cbitmap.h>`

Inheritance diagram for CBitmapPixelAccess:

## Public Member Functions
bool | operator++ ()
| advance position
bool | setPosition (uint32_t x, uint32_t y)
| set current position
uint32_t | getX () const
| return current x position
uint32_t | getY () const
| return current y position
virtual void | getColor (CColor &c) const =0
| get color of current pixel
virtual void | setColor (const CColor &c)=0
| set color of current pixel
void | getValue (uint32_t &value)
| get native color value
void | setValue (uint32_t value)
| set native color value
uint32_t | getBitmapWidth () const
uint32_t | getBitmapHeight () const
IPlatformBitmapPixelAccess * | getPlatformBitmapPixelAccess () const
Public Member Functions inherited from ReferenceCounted< std::atomic< int32_t > >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
| ReferenceCounted ()=default
| ReferenceCounted (const ReferenceCounted &)
virtual | ~ReferenceCounted () noexcept=default
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount

## Static Public Member Functions
static CBitmapPixelAccess * | create (CBitmap *bitmap, bool alphaPremultiplied=true)
| create an accessor.

## Protected Member Functions
| CBitmapPixelAccess ()
| ~CBitmapPixelAccess () noexcept override=default
void | init (CBitmap *bitmap, IPlatformBitmapPixelAccess *pixelAccess)

## Protected Attributes
CBitmap * | bitmap
SharedPointer< IPlatformBitmapPixelAccess > | pixelAccess
uint8_t * | currentPos
uint8_t * | address
uint32_t | bytesPerRow
uint32_t | maxX
uint32_t | maxY
uint32_t | x
uint32_t | y

## Detailed Description

direct pixel access to a CBitmap

## Constructor & Destructor Documentation

## ◆ CBitmapPixelAccess()

CBitmapPixelAccess | ( |  | ) |
| protected

## ◆ ~CBitmapPixelAccess()

~CBitmapPixelAccess | ( |  | ) |
| overrideprotecteddefaultnoexcept

## Member Function Documentation

## ◆ create()

CBitmapPixelAccess * create | ( | CBitmap * | bitmap,
|  | bool | alphaPremultiplied = true )
| static

create an accessor.

can return 0 if platform implementation does not support this. result needs to be forgotten before the CBitmap reflects the change to the pixels

## ◆ getBitmapHeight()

uint32_t getBitmapHeight | ( |  | ) | const
| inline

## ◆ getBitmapWidth()

uint32_t getBitmapWidth | ( |  | ) | const
| inline

## ◆ getColor()

virtual void getColor | ( | CColor & | c | ) | const
| pure virtual

get color of current pixel

## ◆ getPlatformBitmapPixelAccess()

IPlatformBitmapPixelAccess * getPlatformBitmapPixelAccess | ( |  | ) | const
| inline

## ◆ getValue()

void getValue | ( | uint32_t & | value | ) |
| inline

get native color value

## ◆ getX()

uint32_t getX | ( |  | ) | const
| inline

return current x position

## ◆ getY()

uint32_t getY | ( |  | ) | const
| inline

return current y position

## ◆ init()

void init | ( | CBitmap * | bitmap,
|  | IPlatformBitmapPixelAccess * | pixelAccess )
| protected

## ◆ operator++()

bool operator++ | ( |  | ) |
| inline

advance position

## ◆ setColor()

virtual void setColor | ( | const CColor & | c | ) |
| pure virtual

set color of current pixel

## ◆ setPosition()

bool setPosition | ( | uint32_t | x,
|  | uint32_t | y )
| inline

set current position

## ◆ setValue()

void setValue | ( | uint32_t | value | ) |
| inline

set native color value

## Member Data Documentation

## ◆ address

uint8_t* address
| protected

## ◆ bitmap

CBitmap* bitmap
| protected

## ◆ bytesPerRow

uint32_t bytesPerRow
| protected

## ◆ currentPos

uint8_t* currentPos
| protected

## ◆ maxX

uint32_t maxX
| protected

## ◆ maxY

uint32_t maxY
| protected

## ◆ pixelAccess

SharedPointer<IPlatformBitmapPixelAccess> pixelAccess
| protected

## ◆ x

uint32_t x
| protected

## ◆ y

uint32_t y
| protected

The documentation for this class was generated from the following files:

- cbitmap.h
- cbitmap.cpp